<?php
namespace Geral\Entities;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Generator\Business\Field\Date;
use Setforms2\Shared\Registry;

class Ccusclie extends Base\Ccusclie
{
    public static function retornaCentroCustoCliente($nrorg, $cdcliente) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDCLIENTE = ?',
            array(
                $nrorg,
                $cdcliente
            )
        );
        return $obj;
    }

    public static function retornaPrimeiroCentroCustoCliente($nrorg, $cdcliente){
        /** @var $obj Ccusclie */
        $obj = self::retornaCentroCustoCliente($nrorg, $cdcliente);
        if(!$obj instanceof Ccusclie){
            self::insereCentroCustoCliente($nrorg, $cdcliente, '0000000001');
            Registry::getEntityManager()->flush();
            return '0000000001';
        }
        return $obj->getCdccusclie();
    }

    public static function insereCentroCustoCliente($nrorg, $cdcliente, $cdccusclie){
        try{
            $obj = new Ccusclie();
            $obj->setNrorg($nrorg);
            $obj->setCdcliente($cdcliente);
            $obj->setNmccusclie(now());
            $obj->setCdccusclie($cdccusclie);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setIdativo('S');
            $obj->persist();
        }catch (\Exception $e){
            tk_warning($e->getMessage());
        }
    }

}