package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AcompanhamentoAprovCardPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaAcompanhamentoAprovCard = By.xpath("//span[text() = 'Acompanhamento de Aprovação de Cardápio']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"10889986310572390481502\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAcompAprovCardapio = By.xpath("//div[@data-zh-id=\"10889986310572390481502\"]//li[text() = 'Acompanhamento de Aprovação de Cardápio']");

    By campoUnidade = By.id("NMFILIAL");
    By botaoTodasUnidades = By.xpath("//label[@for=\"zh-checkbox-ALLFILIAL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckTodasUnidades = By.id("zh-checkbox-ALLFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 111']");

    By campoServico = By.id("NMSERVICO");
    By botaoTodosServicos = By.xpath("//label[@for=\"zh-checkbox-ALLSERVICO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckTodosServicos = By.id("zh-checkbox-ALLSERVICO");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");
    By servicoAlmoco = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO']");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By botaoCardapioDe = By.xpath("//div[@id=\"MESINICIO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoCardapioDe = By.id("MESINICIO");
    By botaoCardapioAte = By.xpath("//div[@id=\"MESFINAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoCardapioAte = By.id("MESFINAL");
    By mesMarco = By.xpath("//div[@class=\"calendar\"]//div[@class=\"month\"]//div[text() = 'Mar']");
    By mesOutubro = By.xpath("//div[@class=\"calendar\"]//div[@class=\"month\"]//div[text() = 'Out']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"1088998639863655421508\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"10889986329218575291515\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCardapioDe = By.xpath("//div[@data-zh-id=\"108899863510268491522\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCardapioAte = By.xpath("//div[@data-zh-id=\"10889986319842755061523\"]//div[@class=\"zh-validation\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Acompanhamento de Aprovação de Cardápio");
        click(opcaoTelaAcompanhamentoAprovCard);
    }

    public void selecionarRelatorio() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAcompAprovCardapio);
    }

    public void selecionarUnidades() {
        click(campoUnidade);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBc111);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(botaoTodosServicos);
        click(campoServico);
        click(servicoJantar);
        click(servicoAlmoco);
        click(botaoOk);
    }

    public void selecionarMeses() {
        clicarCampoSelecionarValor(campoCardapioDe, mesMarco);
        clicarCampoSelecionarValor(campoCardapioAte, mesOutubro);

        String mesInicial = getText(campoCardapioDe);
        String mesFinal = getText(campoCardapioAte);
        Assert.assertEquals(mesInicial, "03/2023", "Verificação do valor do campo 'cardápio de' após a seleção dos meses");
        Assert.assertEquals(mesFinal, "10/2023", "Verificação do valor do campo 'cardápio até' após a seleção dos meses");
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void selecionarTodasUnidadesEServicos() {
        click(botaoTodasUnidades);
        click(botaoTodosServicos);

        boolean todasUnidades = returnIfElementIsSelected(inputCheckTodasUnidades);
        boolean todosServicos = returnIfElementIsSelected(inputCheckTodosServicos);
        Assert.assertEquals(todasUnidades, true, "Verificação se após clicar no botão todas unidades, o mesmo está selecionado");
        Assert.assertEquals(todosServicos, true, "Verificação se após clicar no botão todos serviços, o mesmo está selecionado");
    }

    public void camposObrigatorios() {
        click(botaoTodosServicos);
        click(botaoCardapioDe);
        click(botaoCardapioAte);
        click(botaoRelatorio);

        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String cardapioDe = getText(mensagemObrigatorioCardapioDe);
        String cardapioAte = getText(mensagemObrigatorioCardapioAte);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo serviço");
        Assert.assertEquals(cardapioDe, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo cardápio de");
        Assert.assertEquals(cardapioAte, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo cardápio até");
    }

    public void mesInicialMaiorQueFinal() {
        clicarCampoSelecionarValor(campoCardapioDe, mesOutubro);
        clicarCampoSelecionarValor(campoCardapioAte, mesMarco);
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "O campo \"Cardápio de\" deve ser menor ou igual ao campo \"Até\"";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela quando tenta gerar um relatório com o mês inicial sendo maior que o final");
        click(botaoOkAlerta);
    }

}
