package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class ApresentacaoProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaGrupoNutrientes = By.xpath("//span[text() = 'Apresentação do Produto']");

    By botaoAbrirOpcoes = By.xpath("//div[@class=\"control-handle\"]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoChinaOficinallis = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CHINA OFFICINALLIS (CASCA)']");

    By botaoAdicionarApresentacao = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"8953314152239560373200\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//li[@data-zh-id=\"8953314152297975244756\"]");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By campoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]/span[1]");
    By botaoCampoRelatorio = By.xpath("//div[@data-zh-id=\"8953314154110302262215\"]//span[@style=\"background-image: none; display: block;\"]");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"8953314154110302262215\"]//div[@class=\"zh-validation\"]/span");
    By botaoGerarRelatorio = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    By campoApresentacao = By.id("NMAPRERECE");
    By apresentacaoGotas = By.xpath("//div[@data-zh-id=\"895331415138204823195\"]//span[text() = '003 | GOTAS']");
    By campoQuantidade = By.id("QTPRODAPRE");

    By checkBoxApresentacao1 = By.xpath("//div[@id=\"grid-8953314152748077114194\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoApresentacao1 = By.xpath("//div[@id=\"grid-8953314152748077114194\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDAPRERECE\"]/span");
    By nomeApresentacao1 = By.xpath("//div[@id=\"grid-8953314152748077114194\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMAPRERECE\"]/span");
    By quantidadeApresentacao1 = By.xpath("//div[@id=\"grid-8953314152748077114194\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPRODAPRE\"]/span");
    By unidadeApresentacao1 = By.xpath("//div[@id=\"grid-8953314152748077114194\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSimAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]//button");
    By mensagemObrigatorioApresentacao = By.xpath("//div[@data-zh-id=\"895331415138204823195\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Apresentação do Produto");
        click(opcaoTelaGrupoNutrientes);
    }

    public void selecionarProduto() {
        tempo();
//        click(botaoAbrirOpcoes);
        click(botaoPesquisar);
        sendKeys(campoProcurar, "CHINA OFFICINALLIS (CASCA)");
        click(produtoChinaOficinallis);
    }

    public void adicionarApresentacao() {
        click(botaoAdicionarApresentacao);
        clicarCampoSelecionarValor(campoApresentacao, apresentacaoGotas);
        sendKeys(campoQuantidade, "4,9");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encCodigo = getText(codigoApresentacao1);
        String encNome = getText(nomeApresentacao1);
        String encQuantidade = getText(quantidadeApresentacao1);
        String encUnidade = getText(unidadeApresentacao1);

        //valores esperados
        String expCodigo = "003";
        String expNome = "GOTAS";
        String expQuantidade = "4,90000";
        String expUnidade = "KG";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código da primeira apresentação adicionada");
        Assert.assertEquals(encNome, expNome, "Verificação do nome da primeira apresentação adicionada");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade da primeira apresentação adicionada");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade da primeira apresentação adicionada");
    }

    public void editarQuantidade() {
        tempo();
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(quantidadeApresentacao1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("3,8").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);
        tempo();

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada no canto superior direito, após salvar a edição");

        //valor encontrado
        String encQuantidade = getText(quantidadeApresentacao1);
        //valor esperado
        String expQuantidade = "3,80000";
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do valor do campo quantidade após a edição");

    }

    public void excluirApresentacao() {
        click(checkBoxApresentacao1);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir a(s) apresentação(ões)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exbida após solicitar a exclusão da apresentação");
        click(botaoSimAlerta);

        tempo();
        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada no canto superior direito, após excluir a apresentação");
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        String nomeRelatorio = getText(campoRelatorio);
        String relatorioEsperado = "Apresentação do Produto";
        Assert.assertEquals(nomeRelatorio, relatorioEsperado, "Verificação do nome do relatório que será gerado");

        click(botaoGerarRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);

        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void camposObrigatoriosAddApresentacao() {
        click(botaoAdicionarApresentacao);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Campo de Quantidade deve ser maior que 0.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após tentar adicionar uma apresentação com a quantidade vazia");
        click(botaoOk);

        sendKeys(campoQuantidade, "0");
        click(botaoSalvar);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Campo de Quantidade deve ser maior que 0.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após tentar adicionar uma apresentação com a quantidade 0");
        click(botaoOk);

        sendKeys(campoQuantidade, "7");
        click(botaoSalvar);
        mensagem = getText(mensagemObrigatorioApresentacao);
        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após tentar adicionar uma apresentação com o campo 'apresentação' vazio");
        tempo();

        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoApresentacao), -150, 0).click().build().perform();
        click(apresentacaoGotas);
        click(botaoSalvar);
        tempo();
    }

    public void campoObrigatorioRelatorio() {
        tempo();
        click(botaoRelatorio);
        click(botaoCampoRelatorio);
        click(botaoGerarRelatorio);

        String mensagem = getText(mensagemObrigatorioRelatorio);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo 'relatório'");
        tempo();
    }

    public void valorObrigatorioEdicaoQuant(){
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(quantidadeApresentacao1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("0").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Campo de Quantidade deve ser maior que 0.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentativa de salvar edição da apresentação com o campo quantidade igual a 0");
        click(botaoOk);

        actions.click(driver.findElement(quantidadeApresentacao1)).build().perform();
        tempo();
        actions.sendKeys(driver.findElement(quantidadeApresentacao1), "6").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);
        tempo();
    }

}
